Index: src/Actions/MoleculeAction/SaveBondsAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SaveBondsAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "bondgraph.hpp"
+#include "config.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
 
 #include <iostream>
@@ -18,15 +31,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "bondgraph.hpp"
-#include "config.hpp"
-#include "defs.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeSaveBondsAction *****/
@@ -53,22 +56,31 @@
 {}
 
+void MoleculeSaveBonds(std::string &bondsfile) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeSaveBondsAction::NAME, bondsfile);
+  ActionRegistry::getInstance().getActionByName(MoleculeSaveBondsAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeSaveBondsAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeSaveBondsAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     DoLog(0) && (Log() << Verbose(0) << "Storing bonds to path " << filename << "." << endl);
     World::getInstance().getConfig()->BG->ConstructBondGraph(mol);
     // TODO: sollte stream, nicht filenamen direkt nutzen, besser fuer unit tests
     mol->StoreBondsToFile(filename);
-    delete dialog;
-    return Action::success;
   }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/SaveBondsAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SaveBondsAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeSaveBonds(std::string &bondsfile);
+
 class MoleculeSaveBondsAction : public Action {
+  friend void MoleculeSaveBonds(std::string &bondsfile);
+
 public:
   MoleculeSaveBondsAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/SaveTemperatureAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SaveTemperatureAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -18,11 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeSaveTemperatureAction *****/
@@ -49,13 +53,25 @@
 {}
 
+void MoleculeSaveTemperature(std::string &temperaturefile) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeSaveTemperatureAction::NAME, temperaturefile);
+  ActionRegistry::getInstance().getActionByName(MoleculeSaveTemperatureAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeSaveTemperatureAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeSaveTemperatureAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     DoLog(1) && (Log() << Verbose(1) << "Storing temperatures in " << filename << "." << endl);
     ofstream output;
@@ -66,9 +82,6 @@
       DoLog(2) && (Log() << Verbose(2) << "File stored." << endl);
     output.close();
-    delete dialog;
-    return Action::success;
   }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/SaveTemperatureAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeSaveTemperature(std::string &temperaturefile);
+
 class MoleculeSaveTemperatureAction : public Action {
+  friend void MoleculeSaveTemperature(std::string &temperaturefile);
+
 public:
   MoleculeSaveTemperatureAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/SuspendInWaterAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SuspendInWaterAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "boundary.hpp"
+#include "config.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -17,12 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "boundary.hpp"
-#include "config.hpp"
-#include "log.hpp"
-#include "config.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeSuspendInWaterAction *****/
@@ -49,14 +53,26 @@
 {}
 
+void MoleculeSuspendInWater(double density) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeSuspendInWaterAction::NAME, density);
+  ActionRegistry::getInstance().getActionByName(MoleculeSuspendInWaterAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeSuspendInWaterAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeSuspendInWaterAction::performCall() {
   molecule *mol = NULL;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   double density;
   double volume = 0.;
 
-  dialog->queryDouble(NAME, &density, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, density);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     DoLog(0) && (Log() << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.");
     if (density < 1.0) {
@@ -64,10 +80,7 @@
     } else {
       PrepareClustersinWater(World::getInstance().getConfig(), mol, volume, density);  // if volume == 0, will calculate from ConvexEnvelope
-      delete dialog;
-      return Action::success;
     }
   }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/SuspendInWaterAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeSuspendInWater(double density);
+
 class MoleculeSuspendInWaterAction : public Action {
+  friend void MoleculeSuspendInWater(double density);
+
 public:
   MoleculeSuspendInWaterAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/VerletIntegrationAction.cpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/VerletIntegrationAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -18,11 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeVerletIntegrationAction *****/
@@ -49,13 +53,25 @@
 {}
 
+void MoleculeVerletIntegration(std::string &forcesfile) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeVerletIntegrationAction::NAME, forcesfile);
+  ActionRegistry::getInstance().getActionByName(MoleculeVerletIntegrationAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeVerletIntegrationAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeVerletIntegrationAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     DoLog(1) && (Log() << Verbose(1) << "Parsing forces file and Verlet integrating." << endl);
     // TODO: sollte besser stream nutzen, nicht filename direkt (es sei denn, ist prefix), besser fuer unit test
@@ -66,10 +82,6 @@
     else
       DoLog(2) && (Log() << Verbose(2) << "File found and parsed." << endl);
-
-    delete dialog;
-    return Action::success;
   }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/VerletIntegrationAction.hpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeVerletIntegration(std::string &forcesfile);
+
 class MoleculeVerletIntegrationAction : public Action {
+  friend void MoleculeVerletIntegration(std::string &forcesfile);
+
 public:
   MoleculeVerletIntegrationAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/ParserAction/LoadXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ParserAction/LoadXyzAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -11,5 +16,11 @@
 
 #include "Actions/ParserAction/LoadXyzAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Parser/XyzParser.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -18,14 +29,7 @@
 #include <vector>
 
-
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** ParserLoadXyzAction *****/
@@ -52,51 +56,34 @@
 {}
 
+void ParserLoadXyz(std::string &filename) {
+  ValueStorage::getInstance().setCurrentValue(ParserLoadXyzAction::NAME, filename);
+  ActionRegistry::getInstance().getActionByName(ParserLoadXyzAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* ParserLoadXyzAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr ParserLoadXyzAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  dialog->queryString(NAME,&filename, NAME);
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
-    DoLog(1) && (Log() << Verbose(1) << "Parsing xyz file for new atoms." << endl);
-    // parse xyz file
-    ifstream input;
-    input.open(filename.c_str());
-    if (!input.fail()) {
-      // TODO: Remove the insertion into molecule when saving does not depend on them anymore. Also, remove molecule.hpp include
-      set <atom*> UniqueList;
-      {
-        vector<atom *> ListBefore = World::getInstance().getAllAtoms();
-        for (vector<atom *>::iterator runner = ListBefore.begin();runner != ListBefore.end(); ++runner)
-          UniqueList.insert(*runner);
-      }
-      XyzParser parser; // briefly instantiate a parser which is removed at end of focus
-      parser.load(&input);
-      {
-        vector<atom *> ListAfter = World::getInstance().getAllAtoms();
-        pair< set<atom *>::iterator, bool > Inserter;
-        if (UniqueList.size() != ListAfter.size()) { // only create if new atoms have been parsed
-          MoleculeListClass *molecules = World::getInstance().getMolecules();
-          molecule *mol = World::getInstance().createMolecule();
-          molecules->insert(mol);
-          for (vector<atom *>::iterator runner = ListAfter.begin(); runner != ListAfter.end(); ++runner) {
-            Inserter = UniqueList.insert(*runner);
-            if (Inserter.second) { // if not present, then new (just parsed) atom, add ...
-              cout << "Adding new atom " << **runner << " to new mol." << endl;
-              mol->AddAtom(*runner);
-            }
-          }
-          mol->doCountAtoms();
-        } else {
-          cout << "No atoms parsed?" << endl;
-        }
-      }
-    } else {
-      DoeLog(1) && (eLog() << Verbose(1) << "Could not open file " << filename << "." << endl);
-    }
-    input.close();
+  DoLog(1) && (Log() << Verbose(1) << "Parsing xyz file for new atoms." << endl);
+  // parse xyz file
+  ifstream input;
+  input.open(filename.c_str());
+  if (!input.fail()) {
+    XyzParser parser; // briefly instantiate a parser which is removed at end of focus
+    parser.load(&input);
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "Could not open file " << filename << "." << endl);
   }
-  delete dialog;
-  return Action::failure;
+  input.close();
+  return Action::success;
 }
 
Index: src/Actions/ParserAction/LoadXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ParserAction/LoadXyzAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,7 +10,11 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
+
+void ParserLoadXyz(std::string &filename);
 
 class ParserLoadXyzAction : public Action {
+  friend void ParserLoadXyz(std::string &filename);
+
 public:
   ParserLoadXyzAction();
@@ -21,4 +25,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/ParserAction/SaveXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ParserAction/SaveXyzAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/ParserAction/SaveXyzAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Parser/XyzParser.hpp"
+#include "atom.hpp"
+#include "molecule.hpp"
 
 #include <iostream>
@@ -18,8 +26,6 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
-#include "atom.hpp"
-#include "molecule.hpp"
 
 /****** ParserSaveXyzAction *****/
@@ -46,20 +52,29 @@
 {}
 
+void ParserSaveXyz(std::string &filename) {
+  ValueStorage::getInstance().setCurrentValue(ParserSaveXyzAction::NAME, filename);
+  ActionRegistry::getInstance().getActionByName(ParserSaveXyzAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* ParserSaveXyzAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr ParserSaveXyzAction::performCall() {
   string filename;
   XyzParser parser;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  dialog->queryString("filename",&filename, "Filename of the xyz file");
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
-    // store xyz file
-    ofstream output;
-    output.open(filename.c_str());
-    if (!output.fail())
-      parser.save(&output);
-    output.close();
-  }
-  delete dialog;
+  // store xyz file
+  ofstream output;
+  output.open(filename.c_str());
+  if (!output.fail())
+    parser.save(&output);
+  output.close();
   return Action::failure;
 }
Index: src/Actions/ParserAction/SaveXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/ParserAction/SaveXyzAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,7 +10,11 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
+
+void ParserSaveXyz(std::string &filename);
 
 class ParserSaveXyzAction : public Action {
+  friend void ParserSaveXyz(std::string &filename);
+
 public:
   ParserSaveXyzAction();
@@ -21,4 +25,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/Process.cpp
===================================================================
--- src/Actions/Process.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/Process.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/SelectionAction/AllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,99 @@
+/*
+ * AllAtomsAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/SelectionAction/AllAtomsAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomDescriptor.hpp"
+#include "atom.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// memento to remember the state when undoing
+
+class SelectionAllAtomsState : public ActionState {
+public:
+  SelectionAllAtomsState(std::vector<atom*> _selectedAtoms) :
+    selectedAtoms(_selectedAtoms)
+  {}
+  std::vector<atom*> selectedAtoms;
+};
+
+const char SelectionAllAtomsAction::NAME[] = "select-all-atoms";
+
+SelectionAllAtomsAction::SelectionAllAtomsAction() :
+  Action(NAME)
+{}
+
+SelectionAllAtomsAction::~SelectionAllAtomsAction()
+{}
+
+void SelectionAllAtoms() {
+  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* SelectionAllAtomsAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr SelectionAllAtomsAction::performCall() {
+  std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms." << endl);
+  World::getInstance().selectAllAtoms(AllAtoms());
+  return Action::state_ptr(new SelectionAllAtomsState(selectedAtoms));
+}
+
+Action::state_ptr SelectionAllAtomsAction::performUndo(Action::state_ptr _state) {
+  SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
+
+  World::getInstance().clearAtomSelection();
+  for(std::vector<atom *>::iterator iter = state->selectedAtoms.begin(); iter != state->selectedAtoms.end(); ++iter)
+    World::getInstance().selectAtom(*iter);
+
+  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+}
+
+Action::state_ptr SelectionAllAtomsAction::performRedo(Action::state_ptr _state){
+  SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
+
+  World::getInstance().selectAllAtoms(AllAtoms());
+
+  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+}
+
+bool SelectionAllAtomsAction::canUndo() {
+  return true;
+}
+
+bool SelectionAllAtomsAction::shouldUndo() {
+  return true;
+}
+
+const string SelectionAllAtomsAction::getName() {
+  return NAME;
+}
Index: src/Actions/SelectionAction/AllAtomsAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/SelectionAction/AllAtomsAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,36 @@
+/*
+ * AllAtomsAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef ALLATOMSACTION_HPP_
+#define ALLATOMSACTION_HPP_
+
+#include "Actions/Action.hpp"
+
+void SelectionAllAtoms();
+
+class SelectionAllAtomsAction : public Action {
+  friend void SelectionAllAtoms();
+
+public:
+  SelectionAllAtomsAction();
+  virtual ~SelectionAllAtomsAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* ALLATOMSACTION_HPP_ */
